Animation = {}
Animation.Image = ""
Animation.Width = 16
Animation.Height = 16
Animation.Active = 0
Animation.Fps = 10

function Animation:new(image, fps)
	object = {}
	object.Image = love.graphics.newImage(image)
	object.Width = object.Image:getWidth()
	object.Height = object.Image:getHeight()
	object.Fps = fps
	setmetatable(object, self)
	self.__index = self
	return object
end

function Animation:play(x, y)
	x=x-self.Height/2
	y=y-self.Height
	love.graphics.setScissor(x, y, self.Height, self.Height)
	love.graphics.setColor(255,255,255)
	love.graphics.draw(self.Image, x-(self.Height*math.floor(self.Active)), y)
	love.graphics.setScissor()
end

function Animation:update(dt)
	self.Active = self.Active + (dt*self.Fps)
	if self.Active > (self.Width/self.Height) then
		self.Active = 0
	end
end