Inventory = {}
Inventory.Player = ""
Inventory.Open = false
Inventory.Berrys = 0
Inventory.BerrysVal = false
Inventory.Rocks = 0
Inventory.RocksVal = false
Inventory.Twigs = 0
Inventory.TwigsVal = false
Inventory.Flint = 0
Inventory.FlintVal = false
Inventory.FirePlace = 0
Inventory.FirePlaceVal = false
Inventory.Pie = 0
Inventory.PieVal = false
Inventory.GoldPie = 0
Inventory.GoldPieVal = false
Inventory.Nugget = 0
Inventory.NuggetVal = false
Inventory.Diamond = 0
Inventory.DiamondVal = false
Inventory.PerlDust = 0
Inventory.PerlDustVal = false
Inventory.Club = 0
Inventory.ClubVal = false
Inventory.CrystalWish = 0
Inventory.CrystalWishVal = false
Inventory.ArtifactA = 0
Inventory.ArtifactAVal = false
Inventory.ArtifactB = 0
Inventory.ArtifactBVal = false
Inventory.ArtifactC = 0
Inventory.ArtifactCVal = false
Inventory.Beam = 0
Inventory.BeamVal = false

function Inventory:new()
	object = {}
	setmetatable(object, self)
	self.__index = self
	return object
end

function Inventory:reset()
	self.BerrysVal = false
	self.RocksVal = false
	self.TwigsVal = false
	self.FlintVal = false
	self.FirePlaceVal = false
	self.PieVal = false
	self.GoldPieVal = false
	self.NuggetVal = false
	self.DiamondVal = false
	self.PerlDustVal = false
	self.ClubVal = false
	self.CrystalWishVal = false
	self.ArtifactAVal = false
	self.ArtifactBVal = false
	self.ArtifactCVal = false
	self.BeamVal = false
end

function Inventory:draw()
	love.graphics.setColor(35, 35, 35)
	love.graphics.rectangle("fill", 198, 15, love.graphics.getWidth()-396, love.graphics.getHeight()-80)
	love.graphics.rectangle("fill", 200, 13, love.graphics.getWidth()-400, love.graphics.getHeight()-76)
	love.graphics.setColor(185, 185, 185)
	love.graphics.rectangle("fill", 200, 15, love.graphics.getWidth()-400, love.graphics.getHeight()-80)

	love.graphics.setColor(235, 235, 235)
	love.graphics.printf("INVENTORY", 0, 20, love.graphics.getWidth(), "center")
	love.graphics.printf("----------------------", 0, 32, love.graphics.getWidth(), "center")
	love.graphics.setColor(35, 35, 35)
	love.graphics.printf("INVENTORY", 0, 18, love.graphics.getWidth(), "center")
	love.graphics.printf("----------------------", 0, 30, love.graphics.getWidth(), "center")

	lineNo = 0
	lineNo = self:drawInvLine(self.Berrys, lineNo, "Berries", self.BerrysVal)
	lineNo = self:drawInvLine(self.Rocks, lineNo, "Rocks", self.RocksVal)
	lineNo = self:drawInvLine(self.Twigs, lineNo, "Twigs", self.TwigsVal)
	lineNo = self:drawInvLine(self.Flint, lineNo, "Flint", self.FlintVal)
	lineNo = self:drawInvLine(self.FirePlace, lineNo, "Fireplace", self.FirePlaceVal)
	lineNo = self:drawInvLine(self.Pie, lineNo, "Pie", self.PieVal)
	lineNo = self:drawInvLine(self.GoldPie, lineNo, "Golden Pie", self.GoldPieVal)
	lineNo = self:drawInvLine(self.Nugget, lineNo, "Gold-Nugget", self.NuggetVal)
	lineNo = self:drawInvLine(self.Diamond, lineNo, "Diamond", self.DiamondVal)
	lineNo = self:drawInvLine(self.PerlDust, lineNo, "Perl-Dust", self.PerlDustVal)
	lineNo = self:drawInvLine(self.Club, lineNo, "Club", self.ClubVal)
	lineNo = self:drawInvLine(self.CrystalWish, lineNo, "Wish-Crystal", self.CrystalWishVal)
	lineNo = self:drawInvLine(self.ArtifactA, lineNo, "Artifact 1/3", self.ArtifactAVal)
	lineNo = self:drawInvLine(self.ArtifactB, lineNo, "Artifact 2/3", self.ArtifactBVal)
	lineNo = self:drawInvLine(self.ArtifactC, lineNo, "Artifact 3/3", self.ArtifactCVal)
	lineNo = self:drawInvLine(self.Beam, lineNo, "Sky-Beam", self.BeamVal)

	okX = love.graphics.getWidth()/2
	okY = love.graphics.getHeight()-60
	boxWidth = 86
	boxHeight = 18
	heightDiff = 20
	love.graphics.setColor(20, 20, 20)
	love.graphics.rectangle("fill", okX-(boxWidth/2), okY+6-heightDiff, boxWidth, boxHeight)
	love.graphics.rectangle("fill", okX-(boxWidth/2)+2, okY+4-heightDiff, boxWidth-4, boxHeight+4)
	love.graphics.setColor(130, 130, 130)
	love.graphics.rectangle("fill", okX-(boxWidth/2)+2, okY+6-heightDiff, boxWidth-4, boxHeight)
	love.graphics.setColor(20, 20, 20)
	love.graphics.printf("Apply", okX+4, okY+8-heightDiff, 0, "center")
	love.graphics.setColor(230, 230, 230)
	love.graphics.printf("Apply", okX+4, okY+6-heightDiff, 0, "center")
end

function Inventory:drawInvLine(objType, line, text, val)
	if(objType > 0)then
		love.graphics.setColor(235, 235, 235)
		love.graphics.print(text, 215, 47+(15*line))
		love.graphics.print("x" .. objType, 345, 47+(15*line))
		love.graphics.setColor(35, 35, 35)
		love.graphics.print(text, 215, 45+(15*lineNo))
		love.graphics.print("x" .. objType, 345, 45+(15*line))

		love.graphics.setColor(35, 35, 35)
		love.graphics.rectangle("fill", 404, 48+(15*lineNo), 12, 12)
		love.graphics.setColor(235, 235, 235)
		love.graphics.rectangle("fill", 406, 50+(15*lineNo), 8, 8)
		if(val)then
			love.graphics.setColor(35, 35, 35)
			love.graphics.rectangle("fill", 408, 52+(15*lineNo), 4, 4)
		end
		line = line + 1
	end
	return line
end

function Inventory:toggleInvValue(objType, line, x, y, value)
	if(objType > 0)then
		if (x >= 404) and (x <= 408+8) then
			if (y >= 48+(15*lineNo)) and (y <= 52+(15*lineNo)+8) then
				value = not(value)
			end
		end
		line = line + 1
	end
	return line, value
end

function Inventory:click(x, y, player)
	-- Handle Check-Boxes
	lineNo = 0
	lineNo, self.BerrysVal = self:toggleInvValue(self.Berrys, lineNo, x, y, self.BerrysVal)
	lineNo, self.RocksVal = self:toggleInvValue(self.Rocks, lineNo, x, y, self.RocksVal)
	lineNo, self.TwigsVal = self:toggleInvValue(self.Twigs, lineNo, x, y, self.TwigsVal)
	lineNo, self.FlintVal = self:toggleInvValue(self.Flint, lineNo, x, y, self.FlintVal)
	lineNo, self.FirePlaceVal = self:toggleInvValue(self.FirePlace, lineNo, x, y, self.FirePlaceVal)
	lineNo, self.PieVal = self:toggleInvValue(self.Pie, lineNo, x, y, self.PieVal)
	lineNo, self.GoldPieVal = self:toggleInvValue(self.GoldPie, lineNo, x, y, self.GoldPieVal)
	lineNo, self.NuggetVal = self:toggleInvValue(self.Nugget, lineNo, x, y, self.NuggetVal)
	lineNo, self.DiamondVal = self:toggleInvValue(self.Diamond, lineNo, x, y, self.DiamondVal)
	lineNo, self.PerlDustVal = self:toggleInvValue(self.PerlDust, lineNo, x, y, self.PerlDustVal)
	lineNo, self.ClubVal = self:toggleInvValue(self.Club, lineNo, x, y, self.ClubVal)
	lineNo, self.CrystalWishVal = self:toggleInvValue(self.CrystalWish, lineNo, x, y, self.CrystalWishVal)
	lineNo, self.ArtifactAVal = self:toggleInvValue(self.ArtifactA, lineNo, x, y, self.ArtifactAVal)
	lineNo, self.ArtifactBVal = self:toggleInvValue(self.ArtifactB, lineNo, x, y, self.ArtifactBVal)
	lineNo, self.ArtifactCVal = self:toggleInvValue(self.ArtifactC, lineNo, x, y, self.ArtifactCVal)
	lineNo, self.BeamVal = self:toggleInvValue(self.Beam, lineNo, x, y, self.BeamVal)

	-- Check if "Apply" is pressed
	toggled = false
	okX = love.graphics.getWidth()/2
	okY = love.graphics.getHeight()-60
	boxWidth = 86
	boxHeight = 18
	heightDiff = 20
	if (x >= okX-(boxWidth/2)+2) and (x <= okX-(boxWidth/2)+2+boxWidth-4) then
		if (y >= okY+4-heightDiff) and (y <= okY+4-heightDiff+boxHeight) then
			self.Open = false
			toggled = true
			self:apply(player)
		end
	end
	return(toggled)
end

function Inventory:apply(player)
	validRecipe = false
	numSel = 0
	if(self.BerrysVal)then numSel = numSel + 1 end
	if(self.RocksVal)then numSel = numSel + 1 end
	if(self.TwigsVal)then numSel = numSel + 1 end
	if(self.FlintVal)then numSel = numSel + 1 end
	if(self.FirePlaceVal)then numSel = numSel + 1 end
	if(self.PieVal)then numSel = numSel + 1 end
	if(self.GoldPieVal)then numSel = numSel + 1 end
	if(self.NuggetVal)then numSel = numSel + 1 end
	if(self.DiamondVal)then numSel = numSel + 1 end
	if(self.PerlDustVal)then numSel = numSel + 1 end
	if(self.ClubVal)then numSel = numSel + 1 end
	if(self.CrystalWishVal)then numSel = numSel + 1 end
	if(self.ArtifactAVal)then numSel = numSel + 1 end
	if(self.ArtifactBVal)then numSel = numSel + 1 end
	if(self.ArtifactCVal)then numSel = numSel + 1 end
	if(self.BeamVal)then numSel = numSel + 1 end

	-- Recipes
	if (self.RocksVal) and (numSel == 1) then
		love.audio.play(sounds.craft)
		message = Message:new("You brake the rock into two flint pieces", 4.0)
		self.Rocks = self.Rocks - 1
		self.Flint = self.Flint + 2
		validRecipe = true
		player.Score = player.Score + 5
	end
	if (self.TwigsVal) and (self.FlintVal) and (numSel == 2) then
		love.audio.play(sounds.craft)
		message = Message:new("That should make a nice fireplace", 4.0)
		self.Twigs = self.Twigs - 1
		self.Flint = self.Flint - 1
		self.FirePlace = self.FirePlace + 1
		validRecipe = true
		player.Score = player.Score + 10
	end
	if (self.TwigsVal) and (self.RocksVal) and (numSel == 2) then
		love.audio.play(sounds.craft)
		message = Message:new("Looks like a hammer or a club", 4.0)
		self.Twigs = self.Twigs - 1
		self.Rocks = self.Rocks - 1
		self.Club = self.Club + 1
		validRecipe = true
		player.Score = player.Score + 20
	end
	if (self.ClubVal) and (self.DiamondVal) and (numSel == 2) then
		love.audio.play(sounds.craft)
		message = Message:new("Both the club and the diamond shatter", 4.0)
		self.Club = self.Club - 1
		self.Diamond = self.Diamond - 1
		self.PerlDust = self.PerlDust + 1
		validRecipe = true
		player.Score = player.Score + 20
	end
	if (self.FirePlaceVal) and (self.BerrysVal) and (numSel == 2) then
		love.audio.play(sounds.craft)
		message = Message:new("Look at that, you made a pie", 4.0)
		self.FirePlace = self.FirePlace - 1
		self.Berrys = self.Berrys - 1
		self.Pie = self.Pie + 1
		validRecipe = true
		player.Score = player.Score + 10
	end
	if (self.PieVal) and (self.NuggetVal) and (numSel == 2) then
		love.audio.play(sounds.craft)
		message = Message:new("The pie transforms into a golden pie!", 4.0)
		self.Pie = self.Pie - 1
		self.Nugget = self.Nugget - 1
		self.GoldPie = self.GoldPie + 1
		validRecipe = true
		player.Score = player.Score + 15
	end
	if (self.BerrysVal) and (numSel == 1) then
		love.audio.play(sounds.eat)
		message = Message:new("Tasty Berries, you feel a bit more energetic", 4.0)
		self.Berrys = self.Berrys - 1
		player.Stamina.Current = player.Stamina.Current + 15
		if(player.Stamina.Current > player.Stamina.Max) then player.Stamina.Current = player.Stamina.Max end
		validRecipe = true
		player.Score = player.Score + 5
	end
	if (self.PieVal) and (numSel == 1) then
		love.audio.play(sounds.eat)
		message = Message:new("That's delicous! No hunger-feelings in sight", 4.0)
		self.Pie = self.Pie - 1
		player.Stamina.Current = player.Stamina.Current + 35
		if(player.Stamina.Current > player.Stamina.Max) then player.Stamina.Current = player.Stamina.Max end
		validRecipe = true
		player.Score = player.Score + 10
	end
	if (self.GoldPieVal) and (numSel == 1) then
		love.audio.play(sounds.eat)
		message = Message:new("Such an amazing taste! Heavenly!", 4.0)
		self.GoldPie = self.GoldPie - 1
		player.Stamina.Current = player.Stamina.Current + 50
		if(player.Stamina.Current > player.Stamina.Max) then player.Stamina.Current = player.Stamina.Max end
		validRecipe = true
		player.Score = player.Score + 10
	end
	if (self.NuggetVal) and (self.DiamondVal) and (numSel == 2) and (self.ArtifactB < 1) and (self.Beam < 1) then
		love.audio.play(sounds.artifact)
		message = Message:new("With a flash the elements turns into an artifact!", 4.0)
		self.Nugget = self.Nugget - 1
		self.Diamond = self.Diamond - 1
		self.ArtifactB = self.ArtifactB + 1
		validRecipe = true
		player.Score = player.Score + 200
	end
	if (self.CrystalWishVal) and (numSel == 1) then
		if(math.random(5) == 5) and (self.ArtifactC < 1) and (self.Beam < 1) then
			love.audio.play(sounds.artifact)
			message = Message:new("From the sky, a strange piece of metal floats down", 4.0)
			self.CrystalWish = self.CrystalWish - 1
			self.ArtifactC = self.ArtifactC + 1
			validRecipe = true
			player.Score = player.Score + 200
		else
			message = Message:new("It's all quiet... No answer", 4.0)
			self.CrystalWish = self.CrystalWish - 1
			validRecipe = true
			player.Score = player.Score + 20
		end
		
	end
	if (self.PerlDustVal) and (self.FlintVal) and (numSel == 2) then
		love.audio.play(sounds.gem)
		message = Message:new("The sparks and smoke leaves a strange crystal", 4.0)
		self.PerlDust = self.PerlDust - 1
		self.Flint = self.Flint - 1
		self.CrystalWish = self.CrystalWish + 1
		validRecipe = true
		player.Score = player.Score + 20
	end
	if (self.ArtifactAVal) and (self.ArtifactBVal) and (self.ArtifactCVal) and (numSel == 3) then
		love.audio.play(sounds.artifact)
		message = Message:new("A mighty flash and thunder melts the artifacts together!", 4.0)
		self.ArtifactA = self.ArtifactA - 1
		self.ArtifactB = self.ArtifactB - 1
		self.ArtifactC = self.ArtifactC - 1
		self.Beam = self.Beam + 1
		validRecipe = true
		player.Score = player.Score + 1000
	end
	if (self.BeamVal) and (numSel == 1) then
		love.audio.play(sounds.skybeam)
		self.Beam = self.Beam - 1
		validRecipe = true
		player.Score = player.Score + 5000
		display = "win"
	end

	if not(validRecipe)then
		if(math.random(2) == 2) then
			message = Message:new("Hmm... That didn't work very well", 4.0)
		else
			message = Message:new("It doesn't seem to work that way", 4.0)
		end
	end
end