require("player")
require("world")
require("userinterface")
require("message")
require("panels")

function love.load()
	math.randomseed(os.time())
	titleBkg = love.graphics.newImage("source/backgroundtitle.png")
	scoreBkg = love.graphics.newImage("source/backgroundscore.png") 
	winBkg = love.graphics.newImage("source/backgroundwin.png")
	font = love.graphics.newFont("source/nicefont.ttf", 16)
	smallFont = love.graphics.newFont("source/nicefont.ttf", 14)
	love.graphics.setFont(font)

	gameType = "Normal"
	message = Message:new("Init Message", 0.0)
	player = Player:new()
	world = World:new()
	world:init()
	ui = UserInterface:new(player, world)

	sounds = {}
	sounds.search = love.audio.newSource("source/search.ogg", static)
	sounds.find = love.audio.newSource("source/find.ogg", static)
	sounds.craft = love.audio.newSource("source/craft.ogg", static)
	sounds.eat = love.audio.newSource("source/eat.ogg", static)
	sounds.gem = love.audio.newSource("source/gem.ogg", static)
	sounds.artifact = love.audio.newSource("source/artifact.ogg", static)
	sounds.skybeam = love.audio.newSource("source/skybeam.ogg", static)

	panel = "title"
end

function love.draw()
	if (panel == "title") then titlePanelDraw()
	elseif (panel == "game") then gamePanelDraw()
	elseif (panel == "score") then scorePanelDraw()	
	elseif(panel == "win")then winPanelDraw()
	end
end

function love.update(dt)
	if (panel == "title") then titlePanelUpdate(dt)
	elseif (panel == "game") then gamePanelUpdate(dt)
	elseif (panel == "score") then scorePanelUpdate(dt)
	elseif(panel == "win")then winPanelUpdate(dt)
	end
end

function love.mousepressed(x, y, button)
	if (panel == "title") then titlePanelClick(x, y)	
	elseif (panel == "game") then gamePanelClick(x, y)		
	elseif(panel == "score")then scorePanelClick(x, y)
	elseif(panel == "win")then winPanelClick(x, y)
	end
end