Message = {}
Message.Text = ""
Message.Time = 0.0
Message.Duration = 1.5
Message.PosY = -40

function Message:new(text, duration)
	object = {}
	object.Text = text
	object.Duration = duration
	setmetatable(object, self)
	self.__index = self
	return object
end

function Message:draw()
	if(self.Time <= self.Duration)then
		-- Draw Message
		love.graphics.setColor(35, 35, 35)
		love.graphics.rectangle("fill", 12, self.PosY, love.graphics.getWidth()-24, 30)
		love.graphics.rectangle("fill", 14, self.PosY, love.graphics.getWidth()-28, 32)
		love.graphics.setColor(85, 85, 85)
		love.graphics.rectangle("fill", 14, self.PosY, love.graphics.getWidth()-28, 30)
		love.graphics.setColor(135, 135, 135)
		love.graphics.printf(self.Text, 0, self.PosY+10, love.graphics.getWidth(), "center")
		love.graphics.setColor(235, 235, 235)
		love.graphics.printf(self.Text, 0, self.PosY+8, love.graphics.getWidth(), "center")
	end
end

function Message:update(dt)
	if(self.Time <= self.Duration)then
		if(self.Time < self.Duration/8)then
			self.PosY = self.PosY + ((dt/self.Duration)*275)
		end
		if(self.Time > (self.Duration/8)*7)then
			self.PosY = self.PosY - ((dt/self.Duration)*275)
		end
		self.Time = self.Time + (dt*1)
	end
end