require("animation")

Object = {}
Object.Sprite = ""
Object.PosX = 0
Object.PosY = 0
Object.Type = ""
Object.TypeEcho = true
Object.TypeName = ""
Object.World = ""
Object.Hoover = false
Object.Loot = ""

function Object:new()
	object = {}
	setmetatable(object, self)
	self.__index = self
	return object
end

function Object:set(world, type, x, y)
	self.World = world
	self.Type = type
	self.PosX = x
	self.PosY = y
	if(type == "grass") then
		self.TypeEcho = false
		if(math.random(2) == 2) then
			self.Sprite = self.World.Sprites.GrassA
		else
			self.Sprite = self.World.Sprites.GrassB
		end
	elseif(type == "tree") then
		self.TypeName = "Tree"
		if(math.random(2) == 2) then
			self.Sprite = self.World.Sprites.TreeA
		else
			self.Sprite = self.World.Sprites.TreeB
		end
		if(math.random(3) == 3) then
			self.Loot = "Twig"
		end
	elseif(type == "stone") then
		self.TypeName = "Rocks"
		self.Sprite = self.World.Sprites.StoneA
		if(math.random(3) == 3) then
			if(math.random(12) == 12) then
				self.Loot = "Diamond"
			else
				self.Loot = "Rock"
			end
		end
	elseif(type == "bush") then
		self.TypeName = "Bush"
		self.Sprite = self.World.Sprites.BushA
		if(math.random(2) == 2) then
			self.Loot = "Berry"
		end
	elseif(type == "softground") then
		self.TypeName = "Gravel"
		self.Sprite = self.World.Sprites.SoftA
		if(math.random(12) > 9) then
			self.Loot = "Flint"
		elseif(math.random(12) > 8) then
			self.Loot = "Gold-Nugget"
		end
	elseif(type == "airplane") then
		self.TypeName = "Crashsite"
		self.Sprite = self.World.Sprites.PlaneA
		if(math.random(12) == 12) then
			if (player.Inventory.ArtifactA < 1) and (player.Inventory.Beam < 1) then
				self.Loot = "Golden Artifact"
			else
				self.Loot = "Pie"
			end
		else
			self.Loot = "Pie"
		end
	end
end

function Object:draw()
	self.Sprite:play(self.PosX, self.PosY)
end

function Object:drawUI()
	if (self.Hoover and self.TypeEcho) then
		boxWidth = 86
		boxHeight = 18
		heightDiff = 20
		widthDiff = 55
		if (love.mouse.getX() < player.PosX) then widthDiff = widthDiff-widthDiff*2	end
		if (self.PosX < 75) then
			widthDiff = 55
		elseif (self.PosX > love.graphics.getWidth()-75) then
			widthDiff = -55
		end
		love.graphics.setColor(20, 20, 20)
		love.graphics.rectangle("fill", self.PosX-4, self.PosY-11, 8, 8)
		love.graphics.rectangle("fill", self.PosX, self.PosY-8, widthDiff, 2)
		love.graphics.rectangle("fill", self.PosX-(boxWidth/2)+widthDiff, self.PosY+4-heightDiff, boxWidth, boxHeight)
		love.graphics.rectangle("fill", self.PosX-(boxWidth/2)+widthDiff+2, self.PosY+2-heightDiff, boxWidth-4, boxHeight+4)
		love.graphics.setColor(130, 130, 130)
		love.graphics.rectangle("fill", self.PosX-(boxWidth/2)+widthDiff+2, self.PosY+4-heightDiff, boxWidth-4, boxHeight)
		love.graphics.setColor(20, 20, 20)
		love.graphics.printf(self.TypeName, self.PosX+widthDiff+4, self.PosY+6-heightDiff, 0, "center")
		love.graphics.setColor(230, 230, 230)
		love.graphics.rectangle("fill", self.PosX-2, self.PosY-9, 4, 4)
		love.graphics.printf(self.TypeName, self.PosX+widthDiff+4, self.PosY+4-heightDiff, 0, "center")
	end
end

function Object:update(player, dt)
	self.Sprite:update(dt)

	-- Check if mouse over
	self.Hoover = false
	if not(player.Inventory.Open)then
		if(player.PosX < self.PosX+30) and (player.PosX > self.PosX-30) then
			if(player.PosY < self.PosY+30) and (player.PosY > self.PosY-30) then
				if(love.mouse.getX() < self.PosX+10) and (love.mouse.getX() > self.PosX-10) then
					if(love.mouse.getY() < self.PosY+10) and (love.mouse.getY() > self.PosY-10) then
						self.Hoover = true
					end
				end
			end
		end
	end
end

function Object:click(player)
	if(self.Loot == "")then
		love.audio.play(sounds.search)
		message = Message:new("Nothing here...", 1.5)
		player.Score = player.Score + 1
	else
		love.audio.play(sounds.find)
		message = Message:new("You found \"" .. self.Loot .. "\"!, it's now added to your inventory", 3)
		player.Score = player.Score + 2
		if(self.Loot == "Berry")then
			player.Inventory.Berrys = player.Inventory.Berrys + 1
		elseif(self.Loot == "Rock")then
			player.Inventory.Rocks = player.Inventory.Rocks + 1
		elseif(self.Loot == "Twig")then
			player.Inventory.Twigs = player.Inventory.Twigs + 1
		elseif(self.Loot == "Pie")then
			player.Inventory.Pie = player.Inventory.Pie + 1
		elseif(self.Loot == "Flint")then
			player.Inventory.Flint = player.Inventory.Flint + 1
		elseif(self.Loot == "Gold-Nugget")then
			love.audio.play(sounds.gem)
			player.Score = player.Score + 8
			player.Inventory.Nugget = player.Inventory.Nugget + 1
		elseif(self.Loot == "Diamond")then
			love.audio.play(sounds.gem)
			player.Score = player.Score + 18
			player.Inventory.Diamond = player.Inventory.Diamond + 1
		elseif(self.Loot == "Golden Artifact")then
			love.audio.play(sounds.artifact)
			player.Score = player.Score + 198
			player.Inventory.ArtifactA = player.Inventory.ArtifactA + 1
		end
		self.Loot = ""
	end
end
