require("object")

Screen = {}
Screen.Objects = {}
Screen.CoordX = 0
Screen.CoordY = 0
Screen.World = ""

function Screen:new()
	object = {}
	object.Objects = {}
	setmetatable(object, self)
	self.__index = self
	return object
end

function Screen:generate(world, x, y)
	self.World = world
	self.CoordX = x
	self.CoordY = y
	-- Generate screen
	---- Add grass to the ground
	for i=1, 75 do
		repeat
			objX = math.random(love.graphics.getWidth()-10)+5
			objY = math.random(love.graphics.getHeight()-10)+5
		until(self:isClear(objX, objY))
		table.insert(self.Objects, Object:new())
		self.Objects[table.getn(self.Objects)]:set(self.World, "grass", objX, objY)
	end
	---- Add trees
	for i=1, math.random(10) do
		repeat
			objX = math.random(love.graphics.getWidth()-50)+25
			objY = math.random(love.graphics.getHeight()-50)+25
		until(self:isClear(objX, objY))
		table.insert(self.Objects, Object:new())
		self.Objects[table.getn(self.Objects)]:set(self.World, "tree", objX, objY)
	end
	---- Add stones
	for i=1, math.random(6) do
		repeat
			objX = math.random(love.graphics.getWidth()-50)+25
			objY = math.random(love.graphics.getHeight()-50)+25
		until(self:isClear(objX, objY))
		table.insert(self.Objects, Object:new())
		self.Objects[table.getn(self.Objects)]:set(self.World, "stone", objX, objY)
	end
	---- Add bushes
	for i=1, math.random(6) do
		repeat
			objX = math.random(love.graphics.getWidth()-50)+25
			objY = math.random(love.graphics.getHeight()-50)+25
		until(self:isClear(objX, objY))
		table.insert(self.Objects, Object:new())
		self.Objects[table.getn(self.Objects)]:set(self.World, "bush", objX, objY)
	end
	---- Add airplanes
	if(math.random(18) == 18) then
		repeat
			objX = math.random(love.graphics.getWidth()-50)+25
			objY = math.random(love.graphics.getHeight()-50)+25
		until(self:isClear(objX, objY))
		table.insert(self.Objects, Object:new())
		self.Objects[table.getn(self.Objects)]:set(self.World, "airplane", objX, objY)
	end
	---- Add softground
	if(math.random(6) == 6) then
		repeat
			objX = math.random(love.graphics.getWidth()-50)+25
			objY = math.random(love.graphics.getHeight()-50)+25
		until(self:isClear(objX, objY))
		table.insert(self.Objects, Object:new())
		self.Objects[table.getn(self.Objects)]:set(self.World, "softground", objX, objY)
	end
end

function Screen:isClear(x, y)
	clash = false
	for k, v in pairs(self.Objects) do
		if(x < v.PosX+20) and (x > v.PosX-20) then
			if(y < v.PosY+20) and (y > v.PosY-20) then
				clash = true
			end
		end
	end
	return not(clash)
end

function Screen:draw(player)
	for i=0, love.graphics.getHeight() do
		for k, v in pairs(self.Objects) do
			if(v.PosY == i) then
				v:draw()
			end
		end
		if (player.State == "Walking") then
			if(player.TargetY > i-1) and (player.TargetY < i+1)then
				player.Animations.Pointer:play(player.TargetX, player.TargetY)
			end
		end
		if(player.PosY > i-1) and (player.PosY < i+1)then
			player:draw()
		end
	end
	for i=0, love.graphics.getHeight() do
		for k, v in pairs(self.Objects) do
			if(v.PosY == i) then
				v:drawUI()
			end
		end
	end
end

function Screen:update(player, dt)
	for k, v in pairs(self.Objects) do
		v:update(player, dt)
	end
	player.AllowMove = true
	for k, v in pairs(self.Objects) do
		if(v.Hoover)then
			player.AllowMove = false
		end
	end
end

function Screen:click(x, y, player)
	if not(player.Inventory.Open)then
		for k, v in pairs(self.Objects) do
			if(v.Hoover)then
				v:click(player)
			end
		end
	end
end