UserInterface = {}
UserInterface.Player = ""
UserInterface.World = ""
UserInterface.Background = love.graphics.newImage("source/background.png")
UserInterface.Hud = love.graphics.newImage("source/hud.png")
UserInterface.Inventory = love.graphics.newImage("source/invent.png")
UserInterface.InventoryOpen = love.graphics.newImage("source/inventopen.png")


function UserInterface:new(player, world)
	object = {}
	object.Player = player
	object.World = world
	setmetatable(object, self)
	self.__index = self
	return object
end

function UserInterface:draw()
	-- Draw Background
	love.graphics.setColor(255, 255, 255)
	love.graphics.draw(self.Background, 0, 0)

	-- Draw World
	self.World:draw(self.Player)

	-- Draw Player Stats
	hudX = love.graphics.getWidth()/2-(self.Hud:getWidth()/2)
	hudY = love.graphics.getHeight()-30-(self.Hud:getHeight()/2)
	
	-- Set transparency if mouse over
	transpVal = 255
	if(love.mouse.getX() > hudX) and (love.mouse.getX() < hudX+self.Hud:getWidth()) then
		if(love.mouse.getY() > hudY) and (love.mouse.getY() < hudY+self.Hud:getHeight()) then
			transpVal = 55
		end
	end

	love.graphics.setColor(255, 255, 255, transpVal)
	love.graphics.draw(self.Hud, hudX, hudY)
	-- Health
	love.graphics.setColor(200, 50, 50, transpVal)
	if (gameType == "Exploration") then love.graphics.setColor(50, 50, 50, transpVal) end
	love.graphics.rectangle("fill", hudX+12, hudY+12, 188*(self.Player.Health.Current/100), 2)
	love.graphics.setColor(100, 25, 25, transpVal)
	if (gameType == "Exploration") then love.graphics.setColor(25, 25, 25, transpVal) end
	love.graphics.rectangle("fill", hudX+12, hudY+14, 188*(self.Player.Health.Current/100), 2)
	-- Stamina
	love.graphics.setColor(200, 200, 50, transpVal)
	if (gameType == "Exploration") then love.graphics.setColor(50, 50, 50, transpVal) end
	love.graphics.rectangle("fill", hudX+12, hudY+22, 188*(self.Player.Stamina.Current/100), 2)
	love.graphics.setColor(100, 100, 25, transpVal)
	if (gameType == "Exploration") then love.graphics.setColor(25, 25, 25, transpVal) end
	love.graphics.rectangle("fill", hudX+12, hudY+24, 188*(self.Player.Stamina.Current/100), 2)

	-- Draw messages
	message:draw()

	-- Draw Inventory
	love.graphics.setColor(255, 255, 255)
	if(self.Player.Inventory.Open)then
		love.graphics.draw(self.InventoryOpen, love.graphics.getWidth()-50, 0)
		self.Player.Inventory:draw()
	else
		love.graphics.draw(self.Inventory, love.graphics.getWidth()-50, 0)
	end
end