require("screen")

World = {}
World.Sprites = {}
World.Sprites.GrassA = Animation:new("source/grassa.png", 1)
World.Sprites.GrassB = Animation:new("source/grassb.png", 1)
World.Sprites.TreeA = Animation:new("source/treea.png", 1)
World.Sprites.TreeB = Animation:new("source/treeb.png", 1)
World.Sprites.StoneA = Animation:new("source/stonea.png", 1)
World.Sprites.StoneB = Animation:new("source/stonea.png", 1)
World.Sprites.BushA = Animation:new("source/busha.png", 1)
World.Sprites.PlaneA = Animation:new("source/airplane.png", 1)
World.Sprites.SoftA = Animation:new("source/softground.png", 1)
World.Screens = {}
World.ActiveCoordX = 0
World.ActiveCoordY = 0

function World:new()
	object = {}
	setmetatable(object, self)
	self.__index = self
	return object
end

function World:init()
	table.insert(self.Screens, Screen:new())
	self.Screens[table.getn(self.Screens)]:generate(self, self.ActiveCoordX, self.ActiveCoordY)
end

function World:draw(player)
	for k, v in pairs(self.Screens) do
		if(v.CoordX == self.ActiveCoordX) and (v.CoordY == self.ActiveCoordY) then
			v:draw(player)
		end
	end
end

function World:update(player, dt)
	for k, v in pairs(self.Screens) do
		if(v.CoordX == self.ActiveCoordX) and (v.CoordY == self.ActiveCoordY) then
			v:update(player, dt)
		end
	end

	-- Check if the player leaves the screen
	if (player.PosX < 20) then
		self.ActiveCoordX = self.ActiveCoordX-1
		player.PosX = love.graphics.getWidth()-30
		player.TargetX = player.PosX
		player.TargetY = player.PosY
		player.State = "Idle"
	elseif (player.PosX > love.graphics.getWidth()-20) then
		self.ActiveCoordX = self.ActiveCoordX+1
		player.PosX = 30
		player.TargetX = player.PosX
		player.TargetY = player.PosY
		player.State = "Idle"
	elseif (player.PosY < 20) then
		self.ActiveCoordY = self.ActiveCoordY-1
		player.PosY = love.graphics.getHeight()-30
		player.TargetX = player.PosX
		player.TargetY = player.PosY
		player.State = "Idle"
	elseif (player.PosY > love.graphics.getHeight()-20) then
		self.ActiveCoordY = self.ActiveCoordY+1
		player.PosY = 30
		player.TargetX = player.PosX
		player.TargetY = player.PosY
		player.State = "Idle"
	end

	-- Create the new screen if it hasn't been visited before
	screenExists = false
	for k, v in pairs(self.Screens) do
		if(v.CoordX == self.ActiveCoordX) and (v.CoordY == self.ActiveCoordY) then
			screenExists = true
		end
	end
	if not(screenExists) then
		table.insert(self.Screens, Screen:new())
		self.Screens[table.getn(self.Screens)]:generate(self, self.ActiveCoordX, self.ActiveCoordY)
	end
end

function World:click(x, y, player)
	for k, v in pairs(self.Screens) do
		if(v.CoordX == self.ActiveCoordX) and (v.CoordY == self.ActiveCoordY) then
			v:click(x, y, player)
		end
	end
end
